// Bitmap1.cpp: implementation of the CBitmap class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "aw1.h"
#include "Bitmap1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBitmapa::CBitmapa()
{
		size_x=size_y=64;
}

CBitmapa::~CBitmapa()
{

}


void CBitmapa::wstaw_pixel(int x, int y, COLORREF kolor)
{
tablica_bmp[x][y]=kolor;
}


 

void CBitmapa::ustaw_kolor_w_tablicy(COLORREF kolor)
{
	int i=size_x;
	int j=size_y;

	for (i=0;i<size_x;i++)
	for (j=0;j<size_y;j++)
	tablica_bmp[i][j]=kolor;
}

COLORREF CBitmapa::zwroc_kolor(int x, int y)
{
return tablica_bmp[x][y];
}


/*--------------------------------------------------------------------*/
/* Zapis do pliku */

int CBitmapa::SaveBitmapFile(const char* nazwa_pliku)  //tak dokladniej to nazwa i sciezka pliku
{
FILE *plik;

  
   if( (plik = fopen( nazwa_pliku, "w" )) != NULL )
   {
      if(fwrite( tablica_bmp, sizeof( COLORREF ), 64*64, plik ))
			{
			fclose( plik );
			return 0;
			}
	}


return 1;
}


/*--------------------------------------------------------------------*/
/* Odczyt z pliku do pliku */

int CBitmapa::OpenBitmapFile(const char* nazwa_pliku)
{
FILE *plik;

   if( (plik = fopen( nazwa_pliku, "r" )) != NULL )
   {
      
      if(fread( tablica_bmp, sizeof( COLORREF ), 64*64, plik ))   
	  {
		  fclose( plik );
		  return 0;		// Oki
	  }
	}

return 1;			// Bd odczytu
}

/*--------------------------------------------------------------------*/
/* Konwertowanie tablicy_bmp do odcieni szarosci*/
void CBitmapa::bmp_grayscale()
{
byte r,g,b;
int res_col;
int i=0,j=0;
for (i=0;i<size_x;i++)
for (j=0;j<size_y;j++)
	{
		r=GetRValue(tablica_bmp[j][i]);
		g=GetGValue(tablica_bmp[j][i]);
		b=GetBValue(tablica_bmp[j][i]);
		res_col=(r+b+g)/3;
		tablica_bmp[j][i]=RGB(res_col,res_col,res_col);
	}

}

/*--------------------------------------------------------------------*/
/* Rozjasnianie obrazka _value -to vartosc o jaka zostana rozjasnione 
skladowe kolorow*/
void CBitmapa::bmp_brightness(int _value)
{
int r,g,b;
int i=0,j=0;
for (i=0;i<size_x;i++)
for (j=0;j<size_y;j++)
	{
		if((r=GetRValue(tablica_bmp[j][i])+_value )>255)r=255;
		if((g=GetGValue(tablica_bmp[j][i])+_value )>255)g=255;
		if((b=GetBValue(tablica_bmp[j][i])+_value )>255)b=255;
		tablica_bmp[j][i]=RGB(r,g,b);
	}

}
/*--------------------------------------------------------------------*/
/* przyciemnianie obrazka _value -to vartosc o jaka zostana przyciemnione 
skladowe kolorow*/
void CBitmapa::bmp_darkness(int _value)
{
int r,g,b;
int i=0,j=0;
for (i=0;i<size_x;i++)
for (j=0;j<size_y;j++)
	{
		if((r=GetRValue(tablica_bmp[j][i])-_value )<0)r=0;
		if((g=GetGValue(tablica_bmp[j][i])-_value )<0)g=0;
		if((b=GetBValue(tablica_bmp[j][i])-_value )<0)b=0;
		tablica_bmp[j][i]=RGB(r,g,b);
	}

}

